diff --git a/functional/SceneGraphTests/src/test/scenegraph/lcd/transparency/Factories.java b/functional/SceneGraphTests/src/test/scenegraph/lcd/transparency/Factories.java
--- a/functional/SceneGraphTests/src/test/scenegraph/lcd/transparency/Factories.java
+++ b/functional/SceneGraphTests/src/test/scenegraph/lcd/transparency/Factories.java
@@ -768,24 +604,19 @@
 
         public void action(Node node) {
             StackPane pane = (StackPane) node;
-            pane.getChildren().add(0, RectangleBuilder.create()
-                        .opacity(0.5)
-                        .fill(Color.BLACK)
-                        .height(100)
-                        .width(100)
-                        .build());
+            Rectangle r = new Rectangle(100, 100);
+            r.setOpacity(0.5);
+            r.setFill(Color.BLACK);
+            pane.getChildren().add(0, r);
         }
     }),
     AddTranslucent01RectangleBeforeText(new Factory() {
 
         public Node createNode(boolean lcd) {
             StackPane value = new StackPane();
-
-            value.getChildren().addAll(
-                    TextBuilder.create()
-                        .text("Test")
-                        .fontSmoothingType(lcd?FontSmoothingType.LCD:FontSmoothingType.GRAY)
-                        .build());
+            Text t = new Text("Test");
+            t.setFontSmoothingType(lcd?FontSmoothingType.LCD:FontSmoothingType.GRAY);
+            value.getChildren().addAll(t);
             return value;
         }
 
@@ -795,24 +626,19 @@
 
         public void action(Node node) {
             StackPane pane = (StackPane) node;
-            pane.getChildren().add(0, RectangleBuilder.create()
-                        .opacity(0.000001d)
-                        .fill(Color.BLACK)
-                        .height(100)
-                        .width(100)
-                        .build());
+            Rectangle r = new Rectangle(100, 100);
+            r.setOpacity(0.000001d);
+            r.setFill(Color.BLACK);
+            pane.getChildren().add(0, r);
         }
     }),
     AddTranslucent09RectangleBeforeText(new Factory() {
 
         public Node createNode(boolean lcd) {
             StackPane value = new StackPane();
-
-            value.getChildren().addAll(
-                    TextBuilder.create()
-                        .text("Test")
-                        .fontSmoothingType(lcd?FontSmoothingType.LCD:FontSmoothingType.GRAY)
-                        .build());
+            Text t = new Text("Test");
+            t.setFontSmoothingType(lcd?FontSmoothingType.LCD:FontSmoothingType.GRAY);
+            value.getChildren().addAll(t);
             return value;
         }
 
@@ -824,12 +650,10 @@
 
         public void action(Node node) {
             StackPane pane = (StackPane) node;
-            pane.getChildren().add(0, RectangleBuilder.create()
-                        .opacity(0.9999999d)
-                        .fill(Color.BLACK)
-                        .height(100)
-                        .width(100)
-                        .build());
+            Rectangle r = new Rectangle(100, 100);
+            r.setOpacity(0.9999999d);
+            r.setFill(Color.BLACK);
+            pane.getChildren().add(r);
             value = false;
         }
     });
diff --git a/functional/SceneGraphTests/src/test/scenegraph/lcd/transparency/TransparencyLCDTextTestApp.java b/functional/SceneGraphTests/src/test/scenegraph/lcd/transparency/TransparencyLCDTextTestApp.java
--- a/functional/SceneGraphTests/src/test/scenegraph/lcd/transparency/TransparencyLCDTextTestApp.java
+++ b/functional/SceneGraphTests/src/test/scenegraph/lcd/transparency/TransparencyLCDTextTestApp.java
@@ -32,16 +32,14 @@
 import javafx.scene.Parent;
 import javafx.scene.Scene;
 import javafx.scene.control.Button;
-import javafx.scene.control.ButtonBuilder;
 import javafx.scene.control.ChoiceBox;
 import javafx.scene.input.MouseEvent;
-import javafx.scene.layout.HBoxBuilder;
+import javafx.scene.layout.HBox;
 import javafx.scene.layout.Pane;
-import javafx.scene.layout.StackPaneBuilder;
-import javafx.scene.layout.VBoxBuilder;
+import javafx.scene.layout.StackPane;
+import javafx.scene.layout.VBox;
 import javafx.scene.paint.Color;
 import javafx.scene.shape.Circle;
-import javafx.scene.shape.CircleBuilder;
 import javafx.scene.text.Text;
 import test.javaclient.shared.InteroperabilityApp;
 import test.javaclient.shared.Utils;
@@ -89,22 +87,15 @@
             }
         });
 
-        applyIndicator = CircleBuilder.create()
-                .id(APPLY_INDICATOR_ID)
-                .radius(5)
-                .fill(Color.RED)
-                .build();
+        applyIndicator = new Circle(5, Color.RED);
+        applyIndicator.setId(APPLY_INDICATOR_ID);
 
-        actionIndicator = CircleBuilder.create()
-                .id(ACTION_INDICATOR_ID)
-                .radius(5)
-                .fill(Color.RED)
-                .build();
+        actionIndicator = new Circle(5, Color.RED);
+        actionIndicator.setId(ACTION_INDICATOR_ID);
 
-        Button applyButton = ButtonBuilder.create()
-                .id(APPLY_BUTTON_ID)
-                .text("Apply")
-                .onMouseClicked(new EventHandler<MouseEvent>() {
+        Button applyButton = new Button("Apply");
+        applyButton.setId(APPLY_BUTTON_ID);
+        applyButton.setOnMouseClicked(new EventHandler<MouseEvent>() {
                     public void handle(MouseEvent t) {
                         if(testingFactory == null){
                             factoryChoicer.getSelectionModel().selectNext();
@@ -113,13 +104,11 @@
                         }
                         applyIndicator.setFill(Color.GREEN);
                     }
-                })
-                .build();
+        });
 
-        Button actionButton = ButtonBuilder.create()
-                .id(ACTION_BUTTON_ID)
-                .text("Action")
-                .onMouseClicked(new EventHandler<MouseEvent>() {
+        Button actionButton = new Button("Action");
+        actionButton.setId(ACTION_BUTTON_ID);
+        actionButton.setOnMouseClicked(new EventHandler<MouseEvent>() {
                     public void handle(MouseEvent t) {
                         Factory currentFactory = TransparencyLCDTextTestApp.this.
                                 factoryChoicer.getSelectionModel().getSelectedItem();
@@ -128,46 +117,32 @@
 
                         actionIndicator.setFill(Color.GREEN);
                     }
-                })
-                .build();
+        });
 
         //Create panes for testing;
-
-
-        rightPane = StackPaneBuilder.create()
-                .id(RIGHT_PANE_ID)
-                .alignment(Pos.CENTER)
-                .minHeight(450)
-                .minWidth(300)
-                .build();
+        rightPane = new StackPane();
+        rightPane.setId(RIGHT_PANE_ID);
+        ((StackPane)rightPane).setAlignment(Pos.CENTER);
+        rightPane.setMinHeight(450);
+        rightPane.setMinWidth(300);
 
         //Create root pane.
-        return VBoxBuilder.create()
-                .id("root")
-                .children(
-                    HBoxBuilder.create()
-                        .padding(new Insets(10))
-                        .spacing(10)
-                        .id("toolsPane")
-                        .alignment(Pos.CENTER)
-                        .children(factoryChoicer, actionButton, applyButton)
-                        .build(),
-                    HBoxBuilder.create()
-                        .padding(new Insets(10))
-                        .spacing(10)
-                        .alignment(Pos.CENTER)
-                        .children(
-                            new Text("Apply"),
-                            applyIndicator,
-                            new Text("Action"),
-                            actionIndicator)
-                        .build(),
-                    HBoxBuilder.create()
-                        .id("testPane")
-                        .alignment(Pos.CENTER)
-                        .children(rightPane)
-                        .build())
-                .build();
+        VBox root = new VBox();
+        root.setId("root");
+        HBox tools = new HBox();
+        tools.setId("toolsPane");
+        tools.setPadding(new Insets(10));
+        tools.setSpacing(10);
+        tools.setAlignment(Pos.CENTER);
+        tools.getChildren().addAll(factoryChoicer, actionButton, applyButton);
+        HBox secondone = new HBox(new Text("Apply"), applyIndicator, new Text("Action"), actionIndicator);
+        secondone.setPadding(new Insets(10));
+        secondone.setSpacing(10);
+        HBox testPane = new HBox(rightPane);
+        testPane.setId("testPane");
+        testPane.setAlignment(Pos.CENTER);
+        root.getChildren().addAll(tools, secondone, testPane);
+        return root;
     }
 
     private void apply() {
diff --git a/tools/FxTestRunner/javatest_base/automated.jti.base b/tools/FxTestRunner/javatest_base/automated.jti.base
--- a/tools/FxTestRunner/javatest_base/automated.jti.base
+++ b/tools/FxTestRunner/javatest_base/automated.jti.base
@@ -5,4 +5,6 @@
 runmode=desktop
 browserPath=firefox
 javawsPath=javaws
-vmOptions=
\ No newline at end of file
+vmOptions=-XX:+IgnoreUnrecognizedVMOptions -Dsun.reflect.debugModuleAccessChecks=true -XX:+TraceAccessControlErrors
+addExports=javafx.graphics/com.sun.prism=ALL-UNNAMED,javafx.base/com.sun.javafx.runtime=ALL-UNNAMED,javafx.graphics/com.sun.javafx.tk=ALL-UNNAMED,javafx.graphics/com.sun.glass.ui=ALL-UNNAMED,javafx.graphics/com.sun.javafx.stage=ALL-UNNAMED,javafx.graphics/com.sun.javafx.scene=ALL-UNNAMED,javafx.graphics/com.sun.javafx.scene.input=ALL-UNNAMED,javafx.graphics/com.sun.javafx.scene.layout.region=ALL-UNNAMED,javafx.controls/javafx.scene.control=ALL-UNNAMED,javafx.controls/javafx.scene.control.skin=ALL-UNNAMED,javafx.controls/com.sun.javafx.scene.control.skin=ALL-UNNAMED,javafx.controls/com.sun.javafx.charts=ALL-UNNAMED,javafx.controls/com.sun.javafx.scene.control=ALL-UNNAMED,javafx.base/com.sun.javafx.collections=ALL-UNNAMED,javafx.base/javafx.event=ALL-UNNAMED
+addExportsEnabled=Yes
diff --git a/tools/FxTestRunner/javatest_base/automated.jti.template b/tools/FxTestRunner/javatest_base/automated.jti.template
--- a/tools/FxTestRunner/javatest_base/automated.jti.template
+++ b/tools/FxTestRunner/javatest_base/automated.jti.template
@@ -1,8 +1,8 @@
 #JT Harness Configuration Interview
 #Tagged (@) values here will be set in 3 steps to support inheritance:
-# 1. from SUITE/javatest_files/automated.jti.base file
-# 2. from ClientTestRunner/javatest_base/automated.jti.base
-# 3. by values setup in ClientTestRunner/javatest_utils.xml
+# 1. from SUITE/javatest_files/automated.jti file
+# 2. from tools/FxTestRunner/javatest_base/automated.jti.base
+# 3. by values setup in tools/FxTestRunner/javatest_utils.xml
 INTERVIEW=@INTERVIEW@
 LOCALE=en_US
 NAME=default
@@ -32,5 +32,7 @@
 browserPath=@browserPath@
 javawsPath=@javawsPath@
 vmOptions=@vmOptions@
+addExports=@addExports@
+addExportsEnabled=@addExportsEnabled@
 remote=@remote@
 @javaPath=@
\ No newline at end of file
diff --git a/tools/FxTestRunner/javatest_base/testsuite.jti.base b/tools/FxTestRunner/javatest_base/testsuite.jti.base
--- a/tools/FxTestRunner/javatest_base/testsuite.jti.base
+++ b/tools/FxTestRunner/javatest_base/testsuite.jti.base
@@ -1,4 +1,8 @@
 #JT Harness Configuration Interview
 #Thu Oct 21 16:48:38 MSD 2010
 INTERVIEW=client.test.runner.BasicFXInterview
-dryrun=No
\ No newline at end of file
+dryrun=No
+vmOptions=-XX:+IgnoreUnrecognizedVMOptions -Dsun.reflect.debugModuleAccessChecks=true -XX:+TraceAccessControlErrors
+#addExports=javafx.graphics/com.sun.prism=ALL-UNNAMED,javafx.base/com.sun.javafx.runtime=ALL-UNNAMED,javafx.graphics/com.sun.javafx.tk=ALL-UNNAMED,javafx.graphics/com.sun.javafx.stage=ALL-UNNAMED,javafx.graphics/com.sun.javafx.scene=ALL-UNNAMED,javafx.base/javafx.event=ALL-UNNAMED,javafx.controls/javafx.scene.control=ALL-UNNAMED,javafx.base/javafx.event=ALL-UNNAMED,javafx.controls/javafx.scene.control=ALL-UNNAMED,javafx.controls/javafx.scene.control.skin=ALL-UNNAMED,javafx.graphics/com.sun.javafx.scene.layout.region=ALL-UNNAMED,javafx.base/com.sun.javafx.collections=ALL-UNNAMED
+addExports=javafx.graphics/com.sun.prism=ALL-UNNAMED,javafx.base/com.sun.javafx.runtime=ALL-UNNAMED,javafx.graphics/com.sun.javafx.tk=ALL-UNNAMED,javafx.graphics/com.sun.glass.ui=ALL-UNNAMED,javafx.graphics/com.sun.javafx.stage=ALL-UNNAMED,javafx.graphics/com.sun.javafx.scene=ALL-UNNAMED,javafx.graphics/com.sun.javafx.scene.input=ALL-UNNAMED,javafx.graphics/com.sun.javafx.scene.layout.region=ALL-UNNAMED,javafx.controls/javafx.scene.control=ALL-UNNAMED,javafx.controls/javafx.scene.control.skin=ALL-UNNAMED,javafx.controls/com.sun.javafx.scene.control.skin=ALL-UNNAMED,javafx.controls/com.sun.javafx.charts=ALL-UNNAMED,javafx.controls/com.sun.javafx.scene.control=ALL-UNNAMED,javafx.base/com.sun.javafx.collections=ALL-UNNAMED,javafx.base/javafx.event=ALL-UNNAMED
+addExportsEnabled=Yes
diff --git a/tools/FxTestRunner/javatest_base/testsuite.jti.template b/tools/FxTestRunner/javatest_base/testsuite.jti.template
--- a/tools/FxTestRunner/javatest_base/testsuite.jti.template
+++ b/tools/FxTestRunner/javatest_base/testsuite.jti.template
@@ -30,6 +30,8 @@
 runmode=desktop
 external.output=@external.output@
 vmOptions=@vmOptions@
+addExports=@addExports@
+addExportsEnabled=@addExportsEnabled@
 remote=@remote@
 @javaPath=@
 dryrun=@dryrun@
\ No newline at end of file
diff --git a/tools/FxTestRunner/src/client/test/AddExports.java b/tools/FxTestRunner/src/client/test/AddExports.java
new file mode 100644
--- /dev/null
+++ b/tools/FxTestRunner/src/client/test/AddExports.java
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2009, 2012, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation. Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package client.test;
+
+import java.lang.annotation.Retention;
+import java.lang.annotation.RetentionPolicy;
+
+/**
+ * Allows to specify necessary values for --add-exports JVM arg
+ * @author Alexander Kouznetsov <Alexander.Kouznetsov@oracle.com>
+ */
+@Retention(RetentionPolicy.RUNTIME)
+public @interface AddExports {
+
+    /**
+     * For now just comma separated values that go to
+     * --add-exports ... JVM argument combined with other values
+     * provided elsewhere
+     * @return
+     */
+    String value();
+}
diff --git a/tools/FxTestRunner/src/client/test/runner/BasicFXInterview.java b/tools/FxTestRunner/src/client/test/runner/BasicFXInterview.java
--- a/tools/FxTestRunner/src/client/test/runner/BasicFXInterview.java
+++ b/tools/FxTestRunner/src/client/test/runner/BasicFXInterview.java
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2009, 2012, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2009, 2016, Oracle and/or its affiliates. All rights reserved.
  * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
  *
  * This code is free software; you can redistribute it and/or modify it
@@ -24,6 +24,7 @@
 
 package client.test.runner;
 
+import static client.test.runner.InterviewUtils.*;
 import client.test.runner.interview.LookAndFeelQuestion;
 import client.test.runner.interview.PipelineGroupQuestion;
 import client.util.CtrUtils;
@@ -127,6 +128,21 @@
     /**
      *
      */
+    public final static String ADD_EXPORTS_PARAM_NAME = "addExports";
+
+    /**
+     *
+     */
+    public final static String XPATCH_PARAM_NAME = "XPatch";
+
+    /**
+     *
+     */
+    public final static String ENABLE_ADD_EXPORTS_PARAM_NAME = "addExportsEnabled";
+
+    /**
+     *
+     */
     public final static String VM_OPTIONS_PARAM_NAME = "vmOptions";
 
     /**
@@ -209,6 +225,10 @@
         return qJavaPath.getValue();
     }
 
+    public String getXPatch() {
+        return qXPatch.getValue();
+    }
+
     /**
      *
      * @return
@@ -730,7 +750,7 @@
 
         @Override
         public String getText() {
-            return "Proxy settings in format: host:port\nE.g. www-proxy.us.oracle.com:80";
+            return "Proxy settings in format: host:port\nE.g. proxy.example.com:80";
         }
 
         @Override
@@ -742,7 +762,7 @@
         public Question getNext() {
             String val = getValue();
             if (val == null || val.trim().length() == 0 || CtrUtils.getProxyUrl(val) != null) {
-                return qVmOptions;
+                return qXPatch;
             } else {
                 return null;
             }
@@ -763,10 +783,112 @@
     private LookAndFeelQuestion qLookAndFeelGroup = new LookAndFeelQuestion (this, qProxy);
     private ChoiceQuestion qPipelineGroup = new PipelineGroupQuestion (this, getLastQuestion());
 
+    private StringQuestion qXPatch = new StringQuestion(this, XPATCH_PARAM_NAME) {
 
-    private static boolean isWindows() {
-        return System.getProperty("os.name").toLowerCase().contains("windows");
+        @Override
+        public String getText() {
+            return "Set -Xpatch directory for the test run. "
+                    + "\nE.g. build/shim-modules";
     }
+
+        @Override
+        public String getSummary() {
+            return "--patch-module";
+        }
+
+        @Override
+        public void clear() {
+            setValue("");
+        }
+
+        @Override
+        public Question getNext() {
+            return qEnableAddExports;
+        }
+
+        @Override
+        public void export(Map data) {
+            data.put(XPATCH_PARAM_NAME, value);
+        }
+
+        @Override
+        public void load(Map data) {
+            String newValue = (String) data.get(XPATCH_PARAM_NAME);
+            setValue(newValue != null ? newValue : "");
+        }
+    };
+
+    private YesNoQuestion qEnableAddExports = new YesNoQuestion(this, ENABLE_ADD_EXPORTS_PARAM_NAME, YesNoQuestion.YES) {
+        @Override
+        public Question getNext() {
+            if (getValue().equals(YES)) {
+                return qAddExports;
+            }
+            return qVmOptions;
+        }
+
+        @Override
+        public String getText() {
+            return "Do you wish to add -XaddExports JVM argument when running tests? "
+                    + "\nAnswer Yes when running with JDK 9 Jigsaw."
+                    + "\nAnswer No when running with JDK 8 and prior.";
+        }
+
+        @Override
+        public String getSummary() {
+            return "Add -XaddExports?";
+        }
+
+        @Override
+        public void export(Map data) {
+            data.put(ENABLE_ADD_EXPORTS_PARAM_NAME, getValue());
+        }
+
+        @Override
+        public void load(Map data) {
+            if (data.containsKey(ENABLE_ADD_EXPORTS_PARAM_NAME)) {
+                setValue((String) data.get(ENABLE_ADD_EXPORTS_PARAM_NAME));
+            }
+        }
+    };
+
+    private StringQuestion qAddExports = new StringQuestion(this, ADD_EXPORTS_PARAM_NAME) {
+
+        @Override
+        public String getText() {
+            return "Set -XaddExports values for the test run. "
+                    + "Individual tests can use @addExports annotation "
+                    + "to add more specific entries to -XaddExports JVM argument."
+                    + "\nE.g. javafx.graphics/com.sun.prism=ALL-UNNAMED,javafx.base/com.sun.javafx.runtime=ALL-UNNAMED";
+        }
+
+        @Override
+        public String getSummary() {
+            return "--add-exports";
+        }
+
+        @Override
+        public void clear() {
+            setValue("");
+        }
+
+        @Override
+        public Question getNext() {
+            return qVmOptions;
+        }
+
+        @Override
+        public void export(Map data) {
+            data.put(ADD_EXPORTS_PARAM_NAME, value);
+        }
+
+        @Override
+        public void load(Map data) {
+            String newValue = (String) data.get(ADD_EXPORTS_PARAM_NAME);
+            setValue(newValue != null ? newValue : "");
+        }
+    };
+
     private StringQuestion qVmOptions = new StringQuestion(this, VM_OPTIONS_PARAM_NAME) {
 
         @Override
@@ -801,24 +923,6 @@
         }
     };
 
-
-
-    private static class ExecutablesFileFilter implements FileFilter {
-        @Override
-        public boolean accept(File file) {
-            return file.exists() && file.canExecute();
-        }
-
-        @Override
-        public boolean acceptsDirectories() {
-            return false;
-        }
-
-        @Override
-        public String getDescription() {
-            return "Executable files";
-        }
-    }
     private static Runnable ieFix = new Runnable() {
         @Override
         public void run() {
diff --git a/tools/FxTestRunner/src/client/test/runner/DrtInterview.java b/tools/FxTestRunner/src/client/test/runner/DrtInterview.java
--- a/tools/FxTestRunner/src/client/test/runner/DrtInterview.java
+++ b/tools/FxTestRunner/src/client/test/runner/DrtInterview.java
@@ -242,7 +242,7 @@
 
         @Override
         public String getText() {
-            return "Proxy settings in format: host:port\nE.g. www-proxy.us.oracle.com:80";
+            return "Proxy settings in format: host:port\nE.g. someproxy.example.com:80";
         }
 
         @Override
diff --git a/tools/FxTestRunner/src/client/test/runner/InterviewUtils.java b/tools/FxTestRunner/src/client/test/runner/InterviewUtils.java
new file mode 100644
--- /dev/null
+++ b/tools/FxTestRunner/src/client/test/runner/InterviewUtils.java
@@ -0,0 +1,54 @@
+/*
+ * Copyright (c) 2015, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation. Oracle designates this
+ * particular file as subject to the "Classpath" exception as provided
+ * by Oracle in the LICENSE file that accompanied this code.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ */
+package client.test.runner;
+
+import com.sun.interview.FileFilter;
+import java.io.File;
+
+/**
+ *
+ * @author akouznet
+ */
+public class InterviewUtils {
+    public static class ExecutablesFileFilter implements FileFilter {
+        @Override
+        public boolean accept(File file) {
+            return file.exists() && file.canExecute();
+        }
+
+        @Override
+        public boolean acceptsDirectories() {
+            return false;
+        }
+
+        @Override
+        public String getDescription() {
+            return "Executable files";
+        }
+    }
+
+    public static boolean isWindows() {
+        return System.getProperty("os.name").toLowerCase().contains("windows");
+    }
+}
diff --git a/tools/FxTestRunner/src/client/test/runner/RunUITestFinder.java b/tools/FxTestRunner/src/client/test/runner/RunUITestFinder.java
--- a/tools/FxTestRunner/src/client/test/runner/RunUITestFinder.java
+++ b/tools/FxTestRunner/src/client/test/runner/RunUITestFinder.java
@@ -24,6 +24,7 @@
 
 package client.test.runner;
 
+import client.test.AddExports;
 import client.test.CheckUI;
 import client.test.Keywords;
 import client.test.RunUI;
@@ -36,12 +37,15 @@
 import java.util.List;
 import java.util.regex.Matcher;
 import java.util.regex.Pattern;
+import java.util.stream.Collectors;
+import java.util.stream.Stream;
 
 /**
  * @author shura
  */
 public class RunUITestFinder extends AbstractTestFinder {
 
+    static final String ADD_EXPORTS = "unit.test.addExports";
     static final String TEST_NAME = "unit.test.testname";
     static final String UNIT_TEST_CLASS_NAME = "unit.test.classname";
     static final String NO_DESCRIPTION = "unit.test.nodescription";
@@ -92,6 +96,7 @@
                 boolean hasCheckUI = findAnnotations(testClass, CheckUI.class).size() > 0;
                 List<String> resources = new ArrayList<String>(runUIs.size());
                 List<Keywords> keys = findAnnotations(testClass, Keywords.class);
+                List<AddExports> addExportsList = findAnnotations(testClass, AddExports.class);
                 if (!runUIs.isEmpty()) {
                     boolean nodescription = false;
                     for (RunUI runUI : runUIs) {
@@ -126,6 +131,17 @@
                             System.out.println("The following keywords \"" + key_str + "\" were found in the test " + file.getName());
                         }
 
+                        // --add-exports value
+                        if (!addExportsList.isEmpty()) {
+                            String[] addExportsArray = new String[addExportsList.size()];
+                            for (int i = 0; i < addExportsList.size(); i++) {
+                                addExportsArray[i] = addExportsList.get(i).value();
+                            }
+                            String addExports = Stream.of(TestScript.combineAddExports(addExportsArray)).collect(Collectors.joining(" "));
+                            tagValues.put(ADD_EXPORTS, addExports);
+                            System.out.println("The following addExports \"" + addExports + "\" were found in the test " + file.getName());
+                        }
+
                         if (nodescription) {
                             tagValues.put("testName", removeDotJavaExtensionFromFilePath(filePath));
                             tagValues.put(FILE_PATH_PROP, path);
